#include<iostream>
#define RACESRC
#ifndef RACESRC
#include<ace/SOCK_Dgram_Mcast.h>
#else
#include"SOCK_Dgram_Mcast.h"
#endif
#include"MeSniMoXML_Dumpable.h"
#define PORT 2000
#include<RACE_Logger.h>
#include<RACE_Logfile.h>
#include<signal.h>

static int ende=0;

void termhandler(int sig)
{
  std::cerr << "Signal " << sig << " arrived" << std::endl;
  ende=1;
}

class MulticastReceiver
{
  short port_;
#ifndef RACESRC
  ACE_SOCK_Dgram_Mcast mcr;
#else
  ACE_INET_Addr localaddr;
  RACE_SOCK_Dgram_MCast mcr;
#endif
public:
  MulticastReceiver(short port):port_(port)
#ifdef RACESRC
  ,localaddr(port),mcr(localaddr)
#endif
  {} 

  void subscribe(const char *addrstr)
  {
    ACE_INET_Addr addr(addrstr);
    addr.set_port_number(port_);
    std::cerr << "Subscribing " << addrstr << std::endl;
    if(mcr.subscribe(addr)<0)
    {
      std::cerr << "can't Subscribe " << addrstr << std::endl;
    }
  }
  void run(const char *logname);
};

void MulticastReceiver::run(const char *logname)
{
  ACE_INET_Addr remoteaddr;
  int r;
  RACE_Logfile *logfile=new RACE_Logfile();
  RACE_LoggerStrategy *loggerstrat = new RACE_LoggerStrategy(logname);
  RACE_Logger *logger;
  logfile->Open(logname);
  
  logger = new RACE_Logger(logfile,loggerstrat);
  logger->activate();
  std::cerr << "Receiving " << logname << " on port UDP " << port_ << std::endl;
  while(ende==0)
  {
    MeSniMo_XML_Dumpable *dump=new MeSniMo_XML_Dumpable(1<<15);
    if((r=mcr.recv(dump->wr_ptr(),dump->size(),remoteaddr))<0)
    {
	std::cerr << "Fehler bei ACE_Dgram_MCast::recv:"
		  << strerror(errno) << std::endl;
	continue;
    }
    char addrstr[64];
    remoteaddr.addr_to_string(addrstr,64);
    dump->wr_ptr(r);
    dump->abschluss();
    std::cerr << dump->length() << " bytes von " << addrstr << std::endl;
    // for(dump->begin();!dump->is_done();dump->advance())
    //{
    //     write(1,dump->base(),dump->length());
    //}
    logger->Log(dump);
  }
  logger->Cancel();
  logger->wait();
  logger->Release();
  
  std::cerr << "done" << std::endl;
}


int main(int argc,char **argv)
{
  struct sigaction sa;
  sa.sa_handler=termhandler;
  sa.sa_flags=0;
  sigemptyset(&(sa.sa_mask));
  sigaddset(&(sa.sa_mask),SIGTERM);
  sigaddset(&(sa.sa_mask),SIGINT);
  sigaction(SIGTERM,&sa,NULL);
  sigaction(SIGINT,&sa,NULL);
  short port=PORT;
  const char *logname="lomo";
  char **arg=argv+1;
  while(*arg!=NULL && **arg=='-')
  {
      if(strcmp(*arg,"-port")==0)
      {
	  port=atoi(*(++arg));
      }
      else if(strcmp(*arg,"-file")==0)
      {
	  logname=*(++arg);
          if(!logname)
	  {
	      std::cerr << "Filenameprefix expected after -file" << std::endl;
	      exit(1);
	  }
      }
      arg++;
  }
  MulticastReceiver mrecv(port);
  while(*arg!=NULL)
  {
    std::cerr << "Subscribe " << *arg << std::endl;
    mrecv.subscribe(*arg);
    arg++;
  }
  mrecv.run(logname);
}
