#include<iostream>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<errorhandling/errorhandling.h>
#include"Railway_Message_Assembler.h"
#include"Railway_Message_Block.h"
#include"dumputility.h"
#include"bitgrabber.h"

class Dumper : public RACE::Message_Observer
{
public:
    Dumper(std::ostream& str):str_(str),mcount_(0) {}
    virtual void process(RACE_Message_Block *mb);
private:
    std::ostream& str_;
    uint32_t mcount_;
};

void Dumper::process(RACE_Message_Block *mb)
{
    Railway_Message_Block *rmb = dynamic_cast<Railway_Message_Block *>(mb);
    if(rmb==0)
    {
	ERRLOG << RACE_LogMsg_Stream::ERROR 
	       << "Unkown type of MessageBlock " 
	       << std::endl;
	mb->release();
	return;
    }
    
    if(rmb->IsFragmented())
    {
	Railway_Message_Block *newrmb =
	    new Railway_Message_Block(rmb->total_length());
	RACE_MEMORY_FAIL(newrmb==0,__FILE__,__LINE__,__FUNCTION__);
	for(mb->begin();!(mb->is_done());mb->advance())
	{
	    newrmb->copy(mb->rd_ptr(),mb->remaining());
	}
	rmb->release();
	rmb = newrmb;
    }
    str_ << "No " << mcount_ << " at " << std::hex << rmb->getoffset() 
	 << " ============= " << rmb->getNID_MESSAGEstr()
	 << " =============" << std::dec << std::endl;
    str_ << "Length(Data)= " << rmb->length() << std::endl;
    rmb->rd_ptr(1);
    str_ << "NID_MESSAGE=" << (int)(rmb->getNID_MESSAGE()) << std::endl;
    size_t L_MESSAGE = rmb->getL_MESSAGE();
    str_ << "L_MESSAGE= " << L_MESSAGE << std::endl;
    if(L_MESSAGE !=  rmb->length())
    {
	str_ << "WARNING: L_MESSAGE != Railway_Message_Block.length()"
	     << std::endl;
    }
    Dumputility::dump_hex(str_,(octet_t *)(rmb->rd_ptr()),rmb->remaining());
    rmb->release();
    mcount_++;
}

int main(int argc,char **argv)
{
    char puffer[4096];
    const char *dsepath =0;
    if(argc<2)
    {
	std::cerr << "Aufruf: " << argv[0] << " datei.dse" << std::endl;
	exit(1);
    }
    dsepath = argv[1];
    
    
    try
    {
	Dumper *dumper = new Dumper(std::cout);
	RACE_MEMORY_FAIL(dumper==0,__FILE__,__LINE__,__FUNCTION__);
	Railway_Message_Assembler *rma=new Railway_Message_Assembler(dumper);
	RACE_MEMORY_FAIL(rma==0,__FILE__,__LINE__,__FUNCTION__);
	int fd=::open(dsepath,O_RDONLY);
	int nr;
	if(fd<0) throw Systemerror(errno,"open","Can't open %s:%m",dsepath);
	while((nr=::read(fd,puffer,4096))>0)
	{
	    rma->input(puffer,nr);
	}
	if(nr<0) throw Systemerror(errno,"read","read(%s):%m",dsepath);
	::close(fd);
    }
    catch(std::exception &ex)
    {
	std::cerr << ex.what() << std::endl;
	exit(1);
    }
}
