#include<iostream>
#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<errorhandling/errorhandling.h>
#include"Railway_Message_Assembler.h"
#include"dumputility.h"

class Dumper : public RACE::Message_Observer
{
public:
    Dumper(std::ostream& str):str_(str) {}
    virtual void process(RACE_Message_Block *mb);
private:
    std::ostream& str_;
};

void Dumper::process(RACE_Message_Block *mb)
{
    str_ << "============== Message Block =============" << std::endl;
    if(!mb->IsFragmented())
    {
	Dumputility::dump_hex(str_,(octet_t *)(mb->rd_ptr()),mb->remaining());
    }
    else
    {
	int i=1;
	for(mb->begin();!(mb->is_done());mb->advance())
	{
	    str_ << "Datablock " << i << std::endl;
	    Dumputility::dump_hex(str_,(octet_t *)(mb->rd_ptr()),mb->remaining());
	}
    }
    mb->release();
}

int main(int argc,char **argv)
{
    char puffer[4096];
    const char *dsepath =0;
    if(argc<2)
    {
	std::cerr << "Aufruf: " << argv[0] << " datei.dse" << std::endl;
	exit(1);
    }
    dsepath = argv[1];
    
    
    try
    {
	Dumper *dumper = new Dumper(std::cout);
	RACE_MEMORY_FAIL(dumper==0,__FILE__,__LINE__,__FUNCTION__);
	Railway_Message_Assembler *rma=new Railway_Message_Assembler(dumper);
	RACE_MEMORY_FAIL(rma==0,__FILE__,__LINE__,__FUNCTION__);
	int fd=::open(dsepath,O_RDONLY);
	int nr;
	if(fd<0) throw Systemerror(errno,"open","Can't open %s:%m",dsepath);
	while((nr=::read(fd,puffer,4096))>0)
	{
	    rma->input(puffer,nr);
	}
	if(nr<0) throw Systemerror(errno,"read","read(%s):%m",dsepath);
	::close(fd);
    }
    catch(std::exception &ex)
    {
	std::cerr << ex.what() << std::endl;
	exit(1);
    }
}
