#ifndef GEOGRAPHICPOSITIONDATA_H
#define GEOGRAPHICPOSITIONDATA_H
#include"NMEA0183_Message_Block.h"

//##Documentation
//## interface for geographic position data
//## This allow the reusing of semantic information
//## in NMEA0183 - Sentences
class GeographicPositionData
{
 public:
    virtual Angle_inDeg getLatitude() throw (NMEA0183_Protocol_Error) =0;

    //##Documentation
    //## true if Latitude in northern sphere
    virtual bool   IsNorth() throw (NMEA0183_Protocol_Error)=0;

    virtual Angle_inDeg getLongitude() throw (NMEA0183_Protocol_Error)=0;

    //##Documentation
    //## true if Longitude in ethern sphere
    virtual bool IsEast() throw (NMEA0183_Protocol_Error)=0;

    //##Documentation
    //## The time fixing
    //## - If the Sensor only know the Time (HHMMSS), the implementation
    //## take the current date from the system clock of the SIU
    virtual ACE_Time_Value getUTCTimeOfFix() throw (NMEA0183_Protocol_Error)=0;
    //##Documentation
    //## if Sensor thinks that its data is good
    virtual bool   IsDataGood() throw (NMEA0183_Protocol_Error)=0;
};
#endif
