#ifndef NMEA0183_CONNECTOR_H
#define NMEA0183_CONNECTOR_H
#include <ace/DEV_Addr.h>
#include <ace/DEV_Connector.h>
#include <ace/DEV_IO.h>
#include <ace/TTY_IO.h>

//##Documentation
//## Factory for open a Serial Line with 4800 bps 8N1 
//## for the NMEA0183-protocoll
//## Design from ACE
class NMEA0183_Connector : public ACE_DEV_Connector
{
 public:
    NMEA0183_Connector(); 
#if 0  
  //##Documentation
  //## Actively connect and produce a <new_stream> if things go well.
  //## The <remote_sap> is the address that we are trying to connect
  //## with.  The <timeout> is the amount of time to wait to connect.
  //## If it's 0 then we block indefinitely.  If  *timeout == {0, 0} then
  //## the connection is done using non-blocking mode.  In this case, if
  //## the connection can't be made immediately the value of -1 is
  //## returned with <errno == EWOULDBLOCK>.  If *timeout > {0, 0} then
  //## this is the maximum amount of time to wait before timing out.  If the
  //## time expires before the connection is made <errno == ETIME>.  The
  //## <local_sap> is the value of local address to bind to.  If it's
  //## the default value of <ACE_Addr::sap_any> then the user is letting
  //## the OS do the binding.  If <reuse_addr> == 1 then the
  //## <local_addr> is reused, even if it hasn't been cleanedup yet.
  //## The <flags> and <perms> arguments are passed down to the <open>
  //## method.
  NMEA0183_Connector (ACE_TTY_IO &new_io,
                     const ACE_DEV_Addr &remote_sap,
                     ACE_Time_Value *timeout = 0,
                     const ACE_Addr &local_sap = ACE_Addr::sap_any,
                     int reuse_addr = 0,
                     int flags = O_RDWR,
                     int perms = 0);
#endif
  //##Documentation
  //## Actively connect and produce a <new_stream> if things go well.
  //## The <remote_sap> is the address that we are trying to connect
  //## with.  The <timeout> is the amount of time to wait to connect.
  //## If it's 0 then we block indefinitely.  If *timeout == {0, 0} then
  //## the connection is done using non-blocking mode.  In this case, if
  //## the connection can't be made immediately the value of -1 is
  //## returned with <errno == EWOULDBLOCK>.  If  *timeout > {0, 0} then
  //## this is the maximum amount of time to wait before timing out.  If the
  //## time expires before the connection is made <errno == ETIME>.  The
  //## <local_sap> is the value of local address to bind to.  If it's
  //## the default value of <ACE_Addr::sap_any> then the user is letting
  //## the OS do the binding.  If <reuse_addr> == 1 then the
  //## <local_addr> is reused, even if it hasn't been cleanedup yet.
  //## The <flags> and <perms> arguments are passed down to the <open>
  //## method.
  int connect (ACE_TTY_IO &new_io,
               const ACE_DEV_Addr &remote_sap,
               ACE_Time_Value *timeout = 0,
               const ACE_Addr &local_sap = ACE_Addr::sap_any,
               int reuse_addr = 0,
               int flags = O_RDWR,
               int perms = 0);

};
#endif
