#ifndef NMEA0183_GLL_H
#define NMEA0183_GLL_H
#include"NMEA0183_Message_Block.h"
#include"GeographicPositionData.h"

class NMEA0183_GLL: public NMEA0183_Message_Block, public GeographicPositionData
{
public:
    NMEA0183_GLL(NMEA0183_Message_Block *mb);
    
    //##Documentation
    //## calls a NMEA0183_Semantik after the Visitor/Semantik-Pattern
    void CallVisitor(RACE_MessageVisitor *visitor);
    
    //##Documentation
    //## field 1
    Angle_inDeg getLatitude() throw (NMEA0183_Protocol_Error);

    //## true if Latitude in northern sphere
    //## if field 2 is 'N'
    bool   IsNorth() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## field 3
    Angle_inDeg getLongitude() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## true if Longitude in ethern sphere
    //## if filed 4 is 'E'
    bool IsEast() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Fields 5 and current date
    ACE_Time_Value getUTCTimeOfFix() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## if field 6 in GLL is 'A'
    bool   IsDataGood() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Constructor for writing
    NMEA0183_GLL(Angle_inDeg latitude,bool north,
		 Angle_inDeg longitude,bool east,
		 ACE_Time_Value timeoffix,
		 bool dataisgood=true);
};
#endif
