#ifndef NMEA0183_GSA_H
#define NMEA0183_GSA_H
#include"NMEA0183_Message_Block.h"

//##Documentation
//## GPS DOP and active satellites
class NMEA0183_GSA: public NMEA0183_Message_Block
{
public:
    NMEA0183_GSA(NMEA0183_Message_Block *mb);
    
    //##Documentation
    //## calls a NMEA0183_Semantik after the Visitor/Semantik-Pattern
    void CallVisitor(RACE_MessageVisitor *visitor);
    
    //##Documentation
    //## Field 1 : Selection Mode: selection of 2D or 3D
    bool isSelectionAutomatic()  throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Field 2 : 2 oder 3D Mode
    int getDimensionMode()  throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Fields 3-14 : Satellite Ids
    std::string getSatelliteID(size_t index) throw (NMEA0183_Protocol_Error);

    //##Documention
    //## fix in the protocol, but the application should abstract over it
    size_t getMaxSatellites() { return 12; }

    //##Documentation
    //## derived: number of known statellites
    int getNumKnownSatellites();

    //##Documentation
    //## Field 15
    double getPDOP_in_m() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Field 16
    double getHDOP_in_m() throw (NMEA0183_Protocol_Error);
    
    //##Documentation
    //## Field 17
    double getVDOP_in_m() throw (NMEA0183_Protocol_Error);
};
#endif
