#include"NMEA0183_GSV.h"
#include"NMEA0183_Semantik.h"

NMEA0183_GSV::NMEA0183_GSV(NMEA0183_Message_Block *mb):NMEA0183_Message_Block(mb)
{
    resetSatelliteDataIterator();
}

void
NMEA0183_GSV::CallVisitor(RACE_MessageVisitor *visitor)
{
    NMEA0183_Semantik *sem = dynamic_cast<NMEA0183_Semantik *>(visitor);
    if(sem)
    {
	sem->common(this);
	sem->GSV(this);
    }
}

int
NMEA0183_GSV::getTotalNumber() throw (NMEA0183_Protocol_Error)
{
    return getIntField(1);
}

int 
NMEA0183_GSV::getMessageNumber() throw (NMEA0183_Protocol_Error)
{
    return getIntField(2); 
}

int 
NMEA0183_GSV::getSatellitesInView() throw (NMEA0183_Protocol_Error)
{
    return getIntField(3);
}

void 
NMEA0183_GSV::resetSatelliteDataIterator()
{
    m_next_index=4;
}

bool
NMEA0183_GSV::getNextSatelliteData(SatData &data) throw (NMEA0183_Protocol_Error)
{
    if(m_next_index+3 > getNumberOfFields()) return false;
    data.prn       = getStringField(m_next_index);
    data.elevation = getDoubleField(m_next_index+1);
    data.azimuth   = getDoubleField(m_next_index+2);
    data.snr       = getDoubleField(m_next_index+3);
    m_next_index += 4;
    return true;
}

NMEA0183_GSV::SatData::SatData():prn(""),elevation(0.0),azimuth(0.0),
				 snr(0.0)
{
}
