#ifndef NMEA0183_GSV_H
#define NMEA0183_GSV_H
#include"NMEA0183_Message_Block.h"

//##Documentation
//## GSV - Satellites in view
class NMEA0183_GSV: public NMEA0183_Message_Block
{
public:
    //##Documentation
    //## Data of Satelites
    struct SatData
    {
	//##Documentation
	//## Satellite PRN Number
	std::string prn; 
	//##Documentation
	//## elevation in degrees
	double elevation;
	//##Documentation
	//## azimuth in degrees to true 
	double azimuth;
	//##Documention
	//## SNR in dB 
	double snr;
	SatData();
    };

    NMEA0183_GSV(NMEA0183_Message_Block *mb);
    
    //##Documentation
    //## calls a NMEA0183_Semantik after the Visitor/Semantik-Pattern
    void CallVisitor(RACE_MessageVisitor *visitor);

    //##Documntation
    //## Field 1 
    int getTotalNumber() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## Field 2
    int getMessageNumber() throw (NMEA0183_Protocol_Error);
    
    //##Documentation
    //## Field 3
    int getSatellitesInView() throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## get the Satdata
    //## call multiple times, returns true if valid, false if the no more
    //## satellite data is avialable
    bool getNextSatelliteData(SatData &data) throw (NMEA0183_Protocol_Error);

    //##Documentation
    //## must be called, if you want Iterate a second time
    void resetSatelliteDataIterator();
private:
    size_t m_next_index;
};
#endif
