#ifndef NMEA0183_MESSAGE_ASSEMBLER_H
#define NMEA0183_MESSAGE_ASSEMBLER_H
#include"RACE_Message_Assembler.h"

//##ModelId=428354D403A5
class NMEA0183_Message_Assembler : public RACE::Message_Assembler
{
public:
    //##ModelId=428354D50217
    NMEA0183_Message_Assembler(RACE::Message_Observer *processor);
public:  
    //##ModelId=428354D403A6
    class StateMashine : public RACE::Message_Assembler::StateMashine
    {
    public:
        //##ModelId=428354D501E7
	StateMashine(RACE::Message_Observer *processor);
        //##ModelId=428354D501E9
	State *getReadHeaderState();
        //##ModelId=428354D501EE
	State *getCollectMessageState();

	State *getEndFieldState();
        //##ModelId=428354D501EF
	State *getWaitForLFState();
	 // abstract states
        //##ModelId=428354D501F0
	//##Documentation
	//## gets first State
	//## Abstract State for trying to reuse
	virtual State *getBeginReadingState();
        //##ModelId=428354D501F2
	//##Documentation
	//## we produce directly NMEA0183_Message_Blocks
	virtual void allocateMessageBlock();
    private:
	State *readheader_;
	State *beginMessage_;
	State *sendMessage_;
	State *collectMessage_;
	State *escape_;
    };

    //##ModelId=428354D403AF
    class WaitForMessageBeginState : public State
    {
    public:
        //##ModelId=428354D501F8
	WaitForMessageBeginState(StateMashine *sm);
        //##ModelId=428354D501FA
	virtual void consume(char c);
        //##ModelId=428354D501FD
	virtual void enter(char c);
    };

    //##ModelId=428354D403B0
    class CollectMessageState : public State
    {
    public:
        //##ModelId=428354D50202
	CollectMessageState(StateMashine *sm);
        //##ModelId=428354D50204
	virtual void consume(char c);
        //##ModelId=428354D50207
	virtual void enter(char c);
    };

    //##Documentation
    //## wait for ',' or '*'
    class EndFieldState : public State
    {
    public:
	EndFieldState(StateMashine *sm);
	virtual void consume(char c);
	virtual void enter(char c);
	//##Documentation
	void setbegin(size_t b);
    private:
	size_t begin_;
    };

    //##ModelId=428354D403B1
    class WaitForLFState : public State
    {
    public:
        //##ModelId=428354D5020C
	WaitForLFState(StateMashine *sm);
        //##ModelId=428354D5020E
	virtual void consume(char c);
        //##ModelId=428354D50211
	virtual void enter(char c);
    };
};
#endif
