#include"NMEA0183_Message_Block.h"
#include"NMEA0183_RMC.h"
#include"NMEA0183_GLL.h"
#include"NMEA0183_GGA.h"
#include"NMEA0183_VTG.h"
#include"NMEA0183_GSA.h"
#include"NMEA0183_GSV.h"
#include"NMEA0183_Processor.h"
#include<stdlib.h>

//##ModelId=428354D5028E
NMEA0183_Processor::NMEA0183_Processor(NMEA0183_Semantik *sem,const char *typelist):m_semantic(sem)
{
    if(typelist!=0)
    {
	m_typelist=typelist;
    }
    else
    {
	m_typelist="all";
    }
}

//##ModelId=428354D50298
NMEA0183_Processor::~NMEA0183_Processor()
{
}

//##ModelId=428354D5029A
void
NMEA0183_Processor::process(RACE_Message_Block *rmb)
{
    NMEA0183_Message_Block *nmb = dynamic_cast<NMEA0183_Message_Block *>(rmb);
    if(nmb!=0)
    {
	if(nmb->getNumberOfFields()==0)
	{
	    if(!nmb->parse())
	    {
		RACE_ERROR("Can't Parse NMEA Message \n");
		return;
	    }
	}
	// Interpretion
	// if SentenceID in Typelist 
	if(m_typelist.find(nmb->getSentenceID())!=std::string::npos
           || m_typelist == "all")
	{
	    if(nmb->getSentenceID()=="RMC")
	    {
 	  	NMEA0183_RMC *rmc = new NMEA0183_RMC(nmb);
 	  	RACE_MEMORY_FAIL(rmc==0,__FILE__,__LINE__,__FUNCTION__);
 	 	nmb->release();
 	 	nmb=rmc;
 	    }
	    else if(nmb->getSentenceID()=="GLL")
	    {
		NMEA0183_GLL *gll = new NMEA0183_GLL(nmb);
		RACE_MEMORY_FAIL(gll==0,__FILE__,__LINE__,__FUNCTION__);
		nmb->release();
		nmb=gll;
	    }
	    else if(nmb->getSentenceID()=="GGA")
	    {
		NMEA0183_GGA *gga = new NMEA0183_GGA(nmb);
		RACE_MEMORY_FAIL(gga==0,__FILE__,__LINE__,__FUNCTION__);
		nmb->release();
		nmb=gga;
	    }
	    else if(nmb->getSentenceID()=="VTG")
	    {
		NMEA0183_VTG *vtg = new NMEA0183_VTG(nmb);
		RACE_MEMORY_FAIL(vtg==0,__FILE__,__LINE__,__FUNCTION__);
		nmb->release();
		nmb=vtg;
	    }
	    else if(nmb->getSentenceID()=="GSA")
	    {
		NMEA0183_GSA *gsa = new NMEA0183_GSA(nmb);
		RACE_MEMORY_FAIL(gsa==0,__FILE__,__LINE__,__FUNCTION__);
		nmb->release();
		nmb=gsa;
	    }
	    else if(nmb->getSentenceID()=="GSV")
	    {
		NMEA0183_GSV *gsv = new NMEA0183_GSV(nmb);
		RACE_MEMORY_FAIL(gsv==0,__FILE__,__LINE__,__FUNCTION__);
		nmb->release();
		nmb=gsv;
	    }
	    nmb->CallVisitor(m_semantic);
        }
    }
    else
    {
	RACE_ERROR("NMEA0183_Processor::process: Can't Process unkown type of RACE_Message_Block ");
    }
    nmb->release();
}
