#ifndef NMEA0183_PROCESSOR
#define NMEA0183_PROCESSOR
#include"RACE_Message_Assembler.h"
#include"NMEA0183_Semantik.h"

//##ModelId=428354D403D7
//##Documentation
//## observes NMEA0183_Sentences (given from NMEA0183_Message_Assembler)
//## narrows to the concrete NMEA0183 adapter class and let a adapter class 
//## call a NMEA0183_Semantik
class NMEA0183_Processor : public RACE::Message_Observer
{
public:
    //##ModelId=428354D5028E
    //##Documentation
    //## the typelist is comma separated string of sentenceIDs
    //## a programm may decide only process Sentencs with types in the list
    //## in this case only the types in the list are narrowed
    NMEA0183_Processor(NMEA0183_Semantik *sem,const char *typelist="all");
    //##ModelId=428354D50298
    virtual ~NMEA0183_Processor();
    //##ModelId=428354D5029A
    //##Documentation
    //## processes a NMEA0183_Message_Block:
    //## narrows it to a specific class and pass the block to a semantic
    virtual void process(RACE_Message_Block *mb);
private:
    //##ModelId=42C3B670008E
    //##Documentation
    //## semantic the message passed to
    NMEA0183_Semantik *m_semantic;
    //##ModelId=42C3B670009E
    //##Documentation 
    //## a comma separated list of NMEA0183 types for filtering
    std::string m_typelist;
};
#endif
