#include"NMEA0183_RMC.h"
#include"NMEA0183_Semantik.h"
#include<ace/OS_NS_time.h>

//##ModelId=428354D502A3
NMEA0183_RMC::NMEA0183_RMC(NMEA0183_Message_Block *b):NMEA0183_Message_Block(b)
{
    
}

//##ModelId=428354D502AD
void NMEA0183_RMC::CallVisitor(RACE_MessageVisitor *visitor)
{
    NMEA0183_Semantik *sem = dynamic_cast<NMEA0183_Semantik *>(visitor);
    if(sem)
    {
	sem->common(this);
	sem->RMC(this);
    }
}

//##ModelId=428354D502AF
ACE_Time_Value NMEA0183_RMC::getUTCTimeOfFix() throw (NMEA0183_Protocol_Error)
{
    //std::cerr << "Feld 9 und 1: " << getStringField(9) << " " << getStringField(1) << std::endl;
    struct tm datetime;
    getDatefromField(datetime,9);
    double fracseconds=0.0;
    getTimefromField(datetime,fracseconds,1);
    datetime.tm_wday=0; // ignored
    datetime.tm_yday=0; // ignored
    datetime.tm_gmtoff=0;
    datetime.tm_zone=0;
    datetime.tm_isdst=-1;
    ACE_Time_Value ret(ACE_OS::mktime(&datetime),0);
    ACE_Time_Value fractv;
    fractv.set(fracseconds);
    ret+=fractv;
    return ret;
}

//##ModelId=428354D502B1
Angle_inDeg NMEA0183_RMC::getLatitude() throw (NMEA0183_Protocol_Error)
{
    return getAngleField(3);
}

//##ModelId=428354D502B7
Angle_inDeg NMEA0183_RMC::getLongitude() throw (NMEA0183_Protocol_Error)
{
    return getAngleField(5);
}

//##ModelId=428354D502B0
bool  NMEA0183_RMC::IsDataGood() throw (NMEA0183_Protocol_Error)
{
    return getBooleanField('A','V',2);
}

//##ModelId=428354D502B6
bool  NMEA0183_RMC::IsNorth() throw (NMEA0183_Protocol_Error)
{
    return getBooleanField('N','S',4);
}

//##ModelId=428354D502B8
bool  NMEA0183_RMC::IsEast() throw (NMEA0183_Protocol_Error)
{
    return getBooleanField('E','W',6); 
}


//##ModelId=428354D502B9
double NMEA0183_RMC::getGroundSpeed_inKnots() throw (NMEA0183_Protocol_Error)
{
    return getDoubleField(7);
}

//##ModelId=428354D502BA
double NMEA0183_RMC::getTrueTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error)
{
    return getDoubleField(8);
}

//##ModelId=428354D502C1
double NMEA0183_RMC::getMagneticVariation_inDegrees() throw (NMEA0183_Protocol_Error)
{ 
    return getDoubleField(10);
}

//##ModelId=428354D502C2
bool NMEA0183_RMC::IsMagneticVariationEast() throw (NMEA0183_Protocol_Error)
{ 
     return getBooleanField('E','W',11); 
}
