#ifndef NMEA0183_RMC_H
#define NMEA0183_RMC_H
#include"NMEA0183_Message_Block.h"
#include"GeographicPositionData.h"
#include"VectorSpeedData.h"

//##ModelId=428354D50004
class NMEA0183_RMC : public NMEA0183_Message_Block, public GeographicPositionData, public VectorSpeedData
{
public:
    //##ModelId=428354D502A3
    NMEA0183_RMC(NMEA0183_Message_Block *mb);

    //##ModelId=428354D502AD
    //##Documentation
    //## calls a NMEA0183_Semantik after the Visitor/Semantik-Pattern
    void CallVisitor(RACE_MessageVisitor *visitor);

    //##ModelId=428354D502AF
    //##Documentation
    //## Fields 9 and 1
    ACE_Time_Value getUTCTimeOfFix() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B0
    //##Documentation
    //## if field 2 in RMC is 'A'
    bool   IsDataGood() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B1
    //##Documentation
    //## field 3
    Angle_inDeg getLatitude() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B6
    //##Documentation
    //## true if Latitude in northern sphere
    //## if field 4 is 'N'
    bool   IsNorth() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B7
    //##Documentation
    //## field 5
    Angle_inDeg getLongitude() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B8
    //##Documentation
    //## true if Longitude in ethern sphere
    //## if filed 6 is 'E'
    bool   IsEast() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502B9
    //##Documentation
    //## Field 7
    double getGroundSpeed_inKnots() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502BA
    //##Documentation
    //## Field 8
    double getTrueTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error);
    
    //##ModelId=428354D502C1
    //##Documentation
    //## Field 10
    double getMagneticVariation_inDegrees() throw (NMEA0183_Protocol_Error);

    //##ModelId=428354D502C2
    //##Documentation
    //## Field 11
    bool IsMagneticVariationEast() throw (NMEA0183_Protocol_Error);
};
#endif
