#include"NMEA0183_VTG.h"
#include"NMEA0183_Semantik.h"

NMEA0183_VTG::NMEA0183_VTG(NMEA0183_Message_Block *mb):NMEA0183_Message_Block(mb)
{
}

void 
NMEA0183_VTG::CallVisitor(RACE_MessageVisitor *visitor)
{
    NMEA0183_Semantik *sem = dynamic_cast<NMEA0183_Semantik *>(visitor);
    if(sem)
    {
	sem->common(this);
	sem->VTG(this);
    }
}

double
NMEA0183_VTG::getTrueTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error)
{
    checkfield("T",2);
    return getDoubleField(1);
}

double
NMEA0183_VTG::getMagneticTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error)
{
    checkfield("M",4);
    return getDoubleField(3);
}

double
NMEA0183_VTG::getGroundSpeed_inKnots() throw (NMEA0183_Protocol_Error)
{
    checkfield("N",6);
    return getDoubleField(5);
}

double 
NMEA0183_VTG::getGroundSpeed_inKpH() throw (NMEA0183_Protocol_Error)
{
    checkfield("K",8);
    return getDoubleField(7);
}
