#ifndef NMEA0183_VTG_H
#define NMEA0183_VTG_H
#include"NMEA0183_Message_Block.h"
#include"VectorSpeedData.h"

class NMEA0183_VTG : public NMEA0183_Message_Block, public VectorSpeedData
{
public:
    NMEA0183_VTG(NMEA0183_Message_Block *mb);

    //##Documentation
    //## calls a NMEA0183_Semantik after the Visitor/Semantik-Pattern
    void CallVisitor(RACE_MessageVisitor *visitor);

    //#Documentation
    //# Field 2 (and field 3 must be T)
    double getTrueTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error);

    //#Documentation
    //# Field 4 (and field 5 must be M)
    double getMagneticTrackMadeGood_inDegrees() throw (NMEA0183_Protocol_Error);
    
    //#Documentation
    //# Field 6 (and field 7 must be N)
    double getGroundSpeed_inKnots() throw (NMEA0183_Protocol_Error);

    //#Documentation
    //# Field 8 (and field 9 must be K)
    double getGroundSpeed_inKpH() throw (NMEA0183_Protocol_Error);
};   
#endif
