#ifndef NAVIGATIONUNITS_H
#define NAVIGATIONUNITS_H
#include"Navigational_Types.h"
#include<math.h>

namespace NavigationUnits
{
    //time
    double const h_in_s=3600.0;
    // distance in meter
    const double km_in_m=1000.0; // kilometer
    const double nm_in_m=1852.0; // nautical mile

    //##Documentation
    //## converts from knots (nautical miles per hour)  to meter per second
    inline double kts2mps(double kps) { return kps*nm_in_m/h_in_s; }
    inline double mps2kts(double mps) { return mps*h_in_s/nm_in_m; }

    inline double deg2rad(Angle_inDeg a)
    {
	return (a.deg+a.min/60.0)*M_PI/180.0;
    }

    // 0 <= ret < 2*M_PI
    inline double deg2rad(double a_in_deg)
    {
	double ret= a_in_deg*M_PI/180.0;
	double nret = fmod(ret,2*M_PI);
	if(nret<0.0) nret+=2*M_PI;
	return nret;
    }

};
#endif
