#include"RACE_Device.h"

envdebug RACE_Device::debug("RACE_Device");

RACE_Device::RACE_Device():fd_(-1)
{
}

void
RACE_Device::open(const char *path,int flags) throw(Systemerror)
{
    debug.print("RACE_Device::open(%s)\n",path_);
    fd_=::open(path,flags);
    if(fd_<0)
    {
	throw Systemerror(errno,"open","open(%s): %m ",path);
    }
    path_=strdup(path);
}

ssize_t
RACE_Device::read(char *buffer,size_t buflen) throw (Systemerror,SystemCallInterrupted)
{
    ssize_t nrecv=::read(fd_,buffer,buflen); 
    if(nrecv==0 || (nrecv<0 && errno == EWOULDBLOCK) ) 
    {
	debug.print("RACE_Device::read %s WOULD BLOCK\n",path_);
	return 0;
    }
    else if(nrecv<0 && errno==EINTR)
    {
	debug.print("RACE_Device::read %s interrupted\n",path_);
	throw SystemCallInterrupted("read");
    }
    else if(nrecv<0 && errno!=EINTR)
    {
	debug.print("RACE_Device::read %s Systemerror\n",path_);
	throw Systemerror(errno,"read","read(%s): %m ",path_);
    }
    debug.print("RACE_Device::read %s returns %d\n",path_,nrecv);
    return nrecv;
}

void
RACE_Device::close()
{
    if(fd_!=-1)
    {
	debug.print("RACE_Device::close %s \n",path_);
	::close(fd_);
	::free((void *)path_);
    }
}

SystemCallInterrupted::SystemCallInterrupted(const char *syscall)
{
    snprintf(msg_,64,"%s was interupted through an signal",syscall);
}

const char *
SystemCallInterrupted::what() const throw()
{
    return msg_;
}
