#include<ace/streams.h>
#include<string.h>
#include"SerialInputHandler.h"
#include<utility_envdebug.h>
static envdebug debug("SerialInputHandler");

SerialInputHandler::SerialInputHandler(ACE_DEV_IO *recv,RACE::Message_Assembler *assembler)
    :m_receiver(recv),m_timeout_timerid(-1), m_timeout_flag(true)
{
    m_buflen=SIH_BUF_LEN;
    m_assembler=assembler;
}

int SerialInputHandler::handle_input(ACE_HANDLE /*fd*/)
{
    ssize_t nrecv;
    m_timeout_flag=false;
    nrecv = m_receiver->recv(m_buffer,SIH_BUF_LEN);
    debug.print("SerialInputHandler::handle_input: %d bytes received ",nrecv);
    if(nrecv<0)
    {
	RACE_ERROR("kommunicationerror:%s",strerror(errno));
	return -1;
    }
    m_assembler->input(m_buffer,nrecv);
    return 0;
}

int SerialInputHandler::handle_timeout(const ACE_Time_Value &/*current_time*/,
				       const void */*act*/)
{
    debug.print("SerialInputHandler::Checkfor Time-out .... ");
    if(m_timeout_flag)
    {
	debug.print("Device is not talking !! ");
    }
    m_timeout_flag=true;
    return 0;
}

void SerialInputHandler::settimerid(long id)
{
    m_timeout_timerid=id;
}

ACE_HANDLE SerialInputHandler::get_handle (void) const
{
    return m_receiver->get_handle();
}

int SerialInputHandler::handle_close(ACE_HANDLE /*handle*/,ACE_Reactor_Mask /*close_mask*/)
{
    debug.print(" SerialInputHandler::handle_close");
    return 0;
}
