// -*- C++ -*- -----------------------------------------------------
//  ----------------------------------------------------------------
//  --
//  -- Project            : SQ2000
//  -- SCU                : INTAPP
//  -- Subunit/Task       : INTAPP_NAV_GPS_Proxy
//  -- File               : $RCSfile: SerialInputHandler.h,v $
//  --
//  -- Prototype showing the working of the ACE-Reactor with the serial 
//  -- line
//  -- Interface to the ACE_Reactor 
//  ----------------------------------------------------------------
//  ----------------------------------------------------------------
//  --   Initial Author       : Rudolf Weber ICS AG
//  --   Last changed by      : $Author: e000593d_intapp $
//  --   Date of last changes : $Date: 2005/04/18 13:46:54 $
//  --   reserved by          : $Locker:  $
//  --   State                : $State: Exp $
//  --
//  --====History=================================================
//  -- $Log: SerialInputHandler.h,v $
//  -- Revision 1.2  2005/04/18 13:46:54  e000593d_intapp
//  -- Build in NMEA0183_Message_Assembler feeding a Buffer for a periodic Consumer-Thread
//  --
//  -- Revision 1.1.1.1  2005/04/08 07:06:13  e000593d_intapp
//  -- Prototype ACE_Reactor and serial lines 
//  --
#ifndef SERIALINPUTHANDLER_H
#define SERIALINPUTHANDLER_H
#include<ace/streams.h>
#include<ace/Reactor.h>
#include<ace/DEV_IO.h>
#include"RACE_Message_Assembler.h"

//##Documentation
//##  Interface to the ACE_Reactor
//##  reads the input
//##  passes the data to the Application
class SerialInputHandler : public ACE_Event_Handler
{
 public:
    SerialInputHandler(ACE_DEV_IO *recv,RACE::Message_Assembler *assembler);
    /// Get the I/O handle.
    virtual ACE_HANDLE get_handle (void) const;
    virtual int handle_input(ACE_HANDLE fd = ACE_INVALID_HANDLE);
    virtual int handle_close(ACE_HANDLE handle,ACE_Reactor_Mask close_mask);

    virtual int handle_timeout(const ACE_Time_Value &current_time,
                              const void *act = 0);
    void settimerid(long id);
 private:
    ACE_DEV_IO *m_receiver;
    long m_timeout_timerid;
    bool m_timeout_flag;
    // provisorisch
#define SIH_BUF_LEN 256
    char m_buffer[SIH_BUF_LEN];
    int m_buflen;
    RACE::Message_Assembler *m_assembler;
};  
#endif /*  SERIALINPUTHANDLER_H */

