#include"NMEA0183_Message_Block.h"
#include<DayTime.hpp>
#include<iostream>
#include<string.h>

void usage()
{
    std::cerr << "Parameter: \n" 
	      << "\t-lat lllll latitude (ignored)\n"
	      << "\t-long lllll logitude (ignored) \n"
	      << "\t-valid_at_warm  Data valid at warmstart\n"
	      << "\t-clear_sat_data \n"
	      << "\t-clear_memory  like cold start\n"
	      << std::endl;
}

int
main(int argc,char **argv)
{
    double latitude=4823.49;
    double longitude=958.39;
    double altitude_in_m = 465.0;
    int resetcfg=0;
    char **arg=argv+1;
    while(*arg!=0)
    {
	if(strcmp("-lat",*arg)==0)
	{
	    ++arg;
	}
	else if(strcmp("-long",*arg)==0)
	{
	    ++arg;
	}
	else if(strcmp("-valid_at_warm",*arg)==0)
	{
	    resetcfg |= 0x01;
	}
	else if(strcmp("-clear_sat_data",*arg)==0)
	{
	    resetcfg |= 0x02;
	}
	else if(strcmp("-clear_memory",*arg)==0)
	{
	    resetcfg |= 0x04;
	}
	else if(strcmp("-?",*arg)==0
		|| strcmp("-help",*arg)==0
		|| strcmp("--help",*arg)==0
	       )
	{
	    usage();
	    exit(-1);
	}
	arg++;
    }
    try
    {
	gpstk::DayTime time;
	NMEA0183_Message_Block *nmb = new NMEA0183_Message_Block(256);
	std::cerr << "The current GPS week is " << time.GPSfullweek() << std::endl;
	std::cerr << "The day of the GPS week is " << time.GPSday() << std::endl;
	std::cerr << "The seconds of the GPS week is " << time.GPSsecond() << std::endl;
	nmb->set("PSRF104,%f,%f,%f,0,%.0f,%hd,%d,%d",latitude,longitude,
		 altitude_in_m,
		 time.GPSsecond(),time.GPSfullweek(),
		 12, // Channels
		 resetcfg
	        );
	nmb->setCheckSum();
	write(1,nmb->base(),nmb->length());
    }
    catch(NMEA0183_Protocol_Error& npe)
    {
	std::cerr << "NMEA0183 Protocollerror " << npe.what() << std::endl;
    }
    catch(gpstk::Exception& gpstkex)
    {
	std::cerr << gpstkex << std::endl;
    }
}
