#include<ace/streams.h>
#include"NMEA0183_Message_Assembler.h"
#include<string.h>
#include<errorhandling/RACE_LogMsg_Stream.h>

class MyPrinter: public RACE::Message_Observer
{
    void process(RACE_Message_Block *mb);
};

void MyPrinter::process(RACE_Message_Block *mb)
{
    cout.write(mb->rd_ptr(),mb->length());
    cout << std::endl; 
    mb->release();
}

int main(int argc,char **argv)
{
    RACE_LOGMSGBACKEND::instance()->init(argc,argv);
    MyPrinter mp;
    NMEA0183_Message_Assembler messageassembler(&mp);
    char *teststr="$RMC,225446,A,4916.45,N,12311.12,W,000.5,054.7,191194,020.3,E*68\r\n";
    messageassembler.input(teststr,strlen(teststr));
    std::cout << "Connecting in the middle of a Sentence " << std::endl;
    teststr="nonsense\r\n$VTG,054.7,T,034.4,M,005.5,N,010.2,K\r\n";
    messageassembler.input(teststr,strlen(teststr));
    std::cout << "The serial interface may be not send CR" << std::endl;
    teststr="$GLL,4916.45,N,12311.12,W,225444,A\r$VTG,054.7,T,034.4,M,005.5,N,010.2,K\r\n";
    messageassembler.input(teststr,strlen(teststr));
    std::cout << "Boken sentence during resetting " << std::endl;
    teststr="$GLL,4916.45,N,12311.12,W,22$VTG,054.7,T,034.4,M,005.5,N,010.2,K\r\n";
    messageassembler.input(teststr,strlen(teststr));
}
