/**
 * Tests examplars of NMEA-Messaging 
 */
#include<ace/streams.h>
#include"NMEA0183_Message_Block.h"
#include"NMEA0183_RMC.h"
#include"NMEA0183_GLL.h"
#include"NMEA0183_VTG.h"
#include"NMEA0183_GGA.h"
#include"NMEA0183_Semantik_Printout.h"
#include"NMEA0183_Processor.h"
//#include<ace/Date_Time.h>

int main(int,char **)
{
    char *teststr[]= {
	"$GPRMC,225446.15,A,4916.45,N,12311.12,W,000.5,054.7,191194,020.3,E*68\r\n",
        "$GPGLL,5321.160,N,00710.361,E,103126,A\r\n",
	"$GPVTG,056.3,T,056.2,M,10.0,N,18.0,K\r\n",
	"$GPGGA,112620,5321.165,N,00710.373,E,1,4,002,+05,M\r\n",
	"$GPGSA,A,1,,,,,,,,,,,,,50.0,50.0,50.0*05\r\n",
	"$GPGSV,3,1,09,30,74,302,00,05,60,083,00,06,43,216,00,02,35,087,00*74\r\n",
	0
    };
    NMEA0183_Semantik *semantic=new NMEA0183_Semantik_Printout();
    NMEA0183_Processor *processor = new NMEA0183_Processor(semantic);

    for(char **sentence=teststr;*sentence!=0;sentence++)
    {
	NMEA0183_Message_Block *nmb=new NMEA0183_Message_Block(*sentence);
	if(!nmb->parse())
	{
	    std::cerr << "Can't parse NMEA0183-message " << std::endl;
	    continue;
	}
	processor->process(nmb);
	std::cout << std::endl;
    }
}

