#include"RACE_Device.h"
#include<errorhandling/errorhandling.h>
#include"NMEA0183_Processor.h"
#include"NMEA0183_Message_Assembler.h"
#include"NMEA0183_Semantik_Printout.h"
RACE_Device device;
#define SERIAL_BUFLEN 4096
char buffer[SERIAL_BUFLEN];

int main(int argc,char **argv)
{
    RACE_LOGMSGBACKEND::instance()->init(argc,argv);
    RACE_LOGMSGBACKEND::instance()->addBackend(new RACE_LogMsg_Bstderr());
    const char *typelist="all";
    char *devicename="/dev/ttyS0";
    bool verbose=false;
    char **arg=argv+1;
    while(*arg!=0)
    {
	if(strcmp(*arg,"-typelist")==0)
	{
	    typelist=*(++arg);
	}
	else if(strcmp(*arg,"-device")==0)
	{
	    devicename=*(++arg);
	}
	else if(strcmp(*arg,"-v")==0)
	{
	    verbose=true;
	}
	arg++;
    }
    ERRLOG << "Typelist = " << typelist
	   << " Devicename=" << devicename << E_EOM;
    NMEA0183_Semantik *sem = new NMEA0183_Semantik_Printout(verbose);
    NMEA0183_Processor *processor = new NMEA0183_Processor(sem,typelist);
    NMEA0183_Message_Assembler *assembler = new NMEA0183_Message_Assembler(processor);
    try
    {
	device.open(devicename,O_RDONLY|O_NDELAY);
	ssize_t nrecv;
    
        while(1)
        {
            nrecv = device.read(buffer,SERIAL_BUFLEN);
            if(nrecv>0)
            {
		assembler->input(buffer,nrecv);
            }
            else
            {
                struct timespec ts;
                ts.tv_sec=1;
                ts.tv_nsec=0;
                nanosleep(&ts,0);
            }
        }
    }
    catch(SystemCallInterrupted &ex)
    {
	ERRLOG << ex.what() << E_EOM;
    }
    catch(Systemerror &serr)
    {
	ERRLOG << serr.what() << E_EOM;
    }

}
