#include<ostream>
#include"EtherDumpable.h"
#include"PCS_EtherAnalyser.h"
PCapDumpable *EtherDumpable::factory(HeaderDumpable *header,RACE_Data_Block *db,RACE_LogfileOffset lo)
{
    return new EtherDumpable(header,db,false,lo);
}

EtherDumpable::EtherDumpable(HeaderDumpable *header,RACE_Data_Block *db,bool frag,RACE_LogfileOffset lo):PCapDumpable(header,db,frag,lo)
{
    rd_ptr(ETHER_HDR_LEN);
}

void printuint8array(std::ostream &str,u_int8_t *a,size_t len)
{
    str << std::hex << (unsigned int)a[0];
    for(size_t i=1;i<len;i++)
    {
	str << ':' << (unsigned int)a[i];
    }
    str << std::dec;
}

void EtherDumpable::printheader(std::ostream& str)
{
    str << "src: ";
    printuint8array(str,getSrcAddr(),getAddrLen());
    str << " dst: ";
    printuint8array(str,getDstAddr(),getAddrLen());
    str << " ";
    switch(getType()) // mehr in /usr/include/linux/if_ether.h
    {
	case ETHERTYPE_PUP : str << "XeroxPUP"; break;
	case ETHERTYPE_IP  : str << "IP"; break;
	case ETHERTYPE_ARP : str << "ARP"; break;
	default:
	    str << "Unknown(" << std::hex << getType() << ")" << std::dec;
    }
}

void  EtherDumpable::CallVisitor(RACE_MessageVisitor *visitor)
{
    PCS_EtherAnalyser *sem=dynamic_cast<PCS_EtherAnalyser *>(visitor);
    if(sem)
    {
	sem->EthernetPacket(this);
    }
    else
    {
	PCapDumpable::CallVisitor(visitor);
    }
}
