#include"HeaderDumpable.h"
#include"PCapSemantik.h"

bool HeaderDumpable::is(octet_t *content,size_t len)
{
    struct pcap_file_header *hdr = (struct pcap_file_header *)content;
    u_int32_t magic = hdr->magic;
    if (magic == TCPDUMP_MAGIC || magic == PATCHED_TCPDUMP_MAGIC) return true;
    numberinterp nip(true);
    hdr->magic=magic = nip.getuint32((char *)&(hdr->magic));
    if (magic == TCPDUMP_MAGIC || magic == PATCHED_TCPDUMP_MAGIC)
	return true;
    return false;
}

HeaderDumpable::HeaderDumpable(RACE_Data_Block *db,bool frag,RACE_LogfileOffset lo):RACE_Dumpable(db,frag,lo),swapped_(false),nip_(false)
{
    RACE_COND_FAIL(frag==true,"%s:%d: HeaderDumple must not be fragmented",
		   __FILE__,__LINE__);
    
    u_int32_t magic = hdr()->magic;
    if (magic != TCPDUMP_MAGIC && magic != PATCHED_TCPDUMP_MAGIC)
    {
	swapped_ = true;
        nip_.setswap(true);
	hdr()->magic=magic = nip_.getuint32((char *)&(hdr()->magic));
	if (magic != TCPDUMP_MAGIC && magic != PATCHED_TCPDUMP_MAGIC)
	{
	    throw Error("bad dump file format");
	}    	
    }
    if (magic == PATCHED_TCPDUMP_MAGIC)
    {
	throw Error("PATCHED_TCPDUMP_MAGIC currently not supported");
    }
    if (hdr()->version_major < PCAP_VERSION_MAJOR)
    {
	throw Error("archaic file format");
    }

}

RACE_Message_Block *HeaderDumpable::CloneManagementData() const
{
  return new HeaderDumpable();
}

swapped_type_t HeaderDumpable::arelengths_swapped()
{
    switch (get_version_major())
    {
	case 2:
                if (get_version_minor() < 3)       return SWAPPED;
                else if (get_version_minor() == 3) return MAYBE_SWAPPED;
                else                               return NOT_SWAPPED;
    
	case 543:
                return SWAPPED;
                                                                                         
        default:
                return NOT_SWAPPED;
        }

}

void HeaderDumpable::CallVisitor(RACE_MessageVisitor *visitor)
{
  PCapSemantik *sem=dynamic_cast<PCapSemantik *>(visitor);
  if(sem)
  {
    sem->Header(this);
  }

}
