#ifndef HEADERDUMPABLE_H
#define HEADERDUMPABLE_H
#include<RACE_Dumpable.h>
#include<binarylayout.h>
#include<numberinterp.h>
#include<RAMS/elementartypes.h>

enum swapped_type_t {
        NOT_SWAPPED,
        SWAPPED,
        MAYBE_SWAPPED
};

class HeaderDumpable : public RACE_Dumpable
{
public:
    HeaderDumpable(int linktype, int thiszone, int snaplen)
        :RACE_Dumpable(sizeof(struct pcap_file_header)),nip_(false)
    {
	struct pcap_file_header *header = (struct pcap_file_header *)base();
	header->magic = TCPDUMP_MAGIC;
	header->version_major = PCAP_VERSION_MAJOR;
	header->version_minor = PCAP_VERSION_MINOR;
	
	header->thiszone = thiszone;
        header->snaplen = snaplen;
        header->sigfigs = 0;
        header->linktype = linktype;
	swapped_=false;
    }

    static bool is(octet_t *content,size_t len);
    HeaderDumpable(RACE_Data_Block *db,bool frag,RACE_LogfileOffset lo);
    u_int16_t get_version_major() { return nip_.getuint16((char *)&(hdr()->version_major)); }
    u_int16_t get_version_minor() { return nip_.getuint16((char *)&(hdr()->version_major)); }
    /* gmt to local correction */
    int32_t   get_thiszone() { return nip_.getint32((char *)&(hdr()->thiszone)); }
    /* accuracy of timestamps */
    u_int32_t get_sigfigs()  { return nip_.getuint32((char *)&(hdr()->sigfigs)); }
    /* max length saved portion of each pkt */
    u_int32_t get_snaplen() { return nip_.getuint32((char *)&(hdr()->snaplen)); }
    /* data link type (LINKTYPE_*) */
    u_int32_t get_linktype() { return nip_.getuint32((char *)&(hdr()->linktype)); }
    size_t getPkHeaderSize() { return hdr()->magic == PATCHED_TCPDUMP_MAGIC ? sizeof(struct pcap_patched_pkthdr) : sizeof(struct pcap_pkthdr); }
    
    bool swapped() { return swapped_; }
    swapped_type_t arelengths_swapped();
    numberinterp &nip() { return nip_; }

    virtual void CallVisitor(RACE_MessageVisitor *visitor);
 protected:
    RACE_Message_Block *CloneManagementData() const;
    HeaderDumpable():RACE_Dumpable() {}
    struct pcap_file_header *hdr() { return (struct pcap_file_header *)base();}
 private:
    bool swapped_;
    numberinterp nip_;
};
#endif
