#include<iostream>
#include"PCS_EtherAnalyser.h"
#include"HeaderDumpable.h"
#include"EtherDumpable.h"
#include"racedatetime.h"
#include"IPv4Message.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include<string>

const char *PCS_EtherAnalyser::name() { return "PCS_EtherAnalyser"; }

void PCS_EtherAnalyser::Header(HeaderDumpable *hd)
{
    std::cerr << "PCS_EtherAnalyser::handle HeaderDumpable at "
	      << hd->GetOffset().part << ':' << hd->GetOffset().offset
	      << std::endl;

}

void PCS_EtherAnalyser::PCapPaket(PCapDumpable *pd)
{
    datetime.update(pd->getTime());
    std::cerr << "PCS_EtherAnalyser::handle PCapDumpable at "
	      << pd->GetOffset().part << ':' << pd->GetOffset().offset << "\t"
	      << datetime
	      << " caplen=" << pd->caplen()
	      << " origpaketlen=" << pd->origpaketlen()
	      << " " << *pd
    	      << std::endl;
    
    
}

void PCS_EtherAnalyser::EthernetPacket(EtherDumpable *ed)
{
    datetime.update(ed->getTime());
    std::cerr << "PCS_EtherAnalyser::handle PCapDumpable at "
	      << ed->GetOffset().part << ':' << ed->GetOffset().offset << "\t"
	      << datetime
	      << " caplen=" << ed->caplen()
	      << " origpaketlen=" << ed->origpaketlen()
	      << " " << *ed
    	      << std::endl;
    switch(ed->getType()) // mehr in /usr/include/linux/if_ether.h
    {
	case ETHERTYPE_PUP : std::cerr << "XeroxPUP"; break;
	case ETHERTYPE_IP  : 
	    {
		IPv4Message *im= new IPv4Message(ed);
		std::string src = inet_ntoa(im->getSrcNO());
		std::string dst = inet_ntoa(im->getDstNO());
		std::cerr << src << " -> " << dst;
		im->release();
	    }   
	    break;
	case ETHERTYPE_ARP : std::cerr << "ARP"; break;
	default:
	    std::cerr << "Unknown(" << std::hex << ed->getType() << ")" << std::dec;
    }
    std::cerr 			  << std::endl;
}
