#include"PCapDumpable.h"
#include"PCapSemantik.h"

PCapDumpable *PCapDumpable::factory(HeaderDumpable *header,RACE_Data_Block *db,RACE_LogfileOffset lo)
{
    return new PCapDumpable(header,db,false,lo);
}

PCapDumpable::PCapDumpable(HeaderDumpable *header,RACE_Data_Block *db,bool frag,RACE_LogfileOffset lo):RACE_Dumpable(db,frag,lo),
		       header_(header),datalen_(0),caplen_(0)
{
    size_t length=determinelength(datalen_,caplen_,(octet_t *)(db->begin()),header);
    if(length);
    rd_ptr(header_->getPkHeaderSize());
}

size_t PCapDumpable::determinelength(u_int32_t& len,u_int32_t &caplen, octet_t *content,HeaderDumpable *header)
{
    pcap_pkthdr *pkthdr = (pcap_pkthdr *)content;
    caplen = header->nip().getuint32((char *)&(pkthdr->caplen));
    len = header->nip().getuint32((char *)&(pkthdr->len));
    switch(header->arelengths_swapped())
    {
	case NOT_SWAPPED:
	    break;
	case MAYBE_SWAPPED:
	    if(caplen  <= len)
	    {
		/*
		 * The captured length is <= the actual length,
		 * so presumably they weren't swapped.
		 */
		break;
	    }
	    /* FALLTHROUGH */
        case SWAPPED:
	    {
		u_int32_t h=caplen;
		caplen=len;
		len=h;
	    }
    }
    return (header->getPkHeaderSize()+caplen);
}

ACE_Time_Value PCapDumpable::getTime()
{
    numberinterp& nip = header_->nip();
    pcap_pkthdr* hdr=(pcap_pkthdr*)base();
    pcap_timeval *tv=&(hdr->ts);
    return ACE_Time_Value(nip.getint32((char *)&(tv->tv_sec)),
			  nip.getint32((char *)&(tv->tv_usec)));
}

void PCapDumpable::CallVisitor(RACE_MessageVisitor *visitor)
{
  PCapSemantik *sem=dynamic_cast<PCapSemantik *>(visitor);
  if(sem)
  {
    sem->PCapPaket(this);
  }

}

void PCapDumpable::printheader(std::ostream& str)
{
    str << "unbekannt ";
}
