#ifndef numberinterp_h
#define numberinterp_h
#include<sys/types.h>
/**
 * Interpretation of numbers in buffers
 * The data may be misaligned or byte swapped
 */
class numberinterp
{
 public:
    numberinterp(bool swap=false):swap_(swap) {}
    void setswap(bool swap) { swap_=swap; }
    u_int32_t getuint32(char *b)
    {
	u_int32_t lp;
	char *pc;
	u_int32_t ret;
	if((long)b%4==0)
	{
	    pc=b;
	}
	else
	{
	    pc=(char *)&lp;
	    memcpy(pc,b,sizeof(u_int32_t));
	}
	ret=*(u_int32_t *)pc;
	if(swap_)
	{
	    return (((ret&0xff)<<24) | ((ret&0xff00)<<8) | ((ret&0xff0000)>>8) | ((ret>>24)&0xff));
	}
	else
	{
	    return ret;
	}
    }

    u_int16_t getuint16(char *b)
    {
	u_int16_t sp;
	char *pc;
	u_int16_t ret;
	if((long)b%2==0)
	{
	    pc=b;
	}
	else
	{
	    pc=(char *)&sp;
	    memcpy(pc,b,sizeof(u_int16_t));
	}
	ret=*(u_int16_t *)pc;
	if(swap_)
	{
	    return (((ret&0xff)<<8) | ((u_int16_t)(ret&0xff00)>>8));
	}
	else
	{
	    return ret;
	}
    }

    int32_t getint32(char *b)
    {
	/* Fixme: wie ist das definiert ? */
	return (int32_t)getuint32(b);
    }
 private:
    bool swap_;
};
#endif
