#include"pcapinterpreter.h"
#include<binarylayout.h>
#include<iostream>
bool PcapInterpreter::setcontent(RACE_LogfileOffset lo,octet_t *content,size_t len)
{
    if(lo.offset==0)
    {
	if(len<sizeof(struct pcap_file_header)) return false;
	if((headerdump_=HeaderDumpable::is(content,len)))
	{
	    len_= sizeof(struct pcap_file_header);
	    return true;
	}
    }
    if(header_==0) throw Error("No Header Read at begin ");
    if(len < header_->getPkHeaderSize()) return false;
    u_int32_t hlen,hpcaplen;
    len_=PCapDumpable::determinelength(hlen,hpcaplen,content,header_);
    return true;
}

size_t PcapInterpreter::length() { return len_; }

RACE_Dumpable *PcapInterpreter::interpret(RACE_Data_Block *db,bool fragmented,RACE_LogfileOffset lo)
{
    RACE_Dumpable *ret=0;
    if(headerdump_) 
    {
	RACE_COND_FAIL(fragmented,"Headerdumpables are never fregmented ");
	ret = new HeaderDumpable(db,fragmented,lo);
	RACE_MEMORY_FAIL(!ret,__FILE__,__LINE__,__FUNCTION__);
	header_=ACE_dynamic_cast(HeaderDumpable *,ret->clone());
	headerdump_=false;
	std::cerr << "LinkType " << linktype2str(header_->get_linktype())
		  << std::endl;
	gendumpable=dumpablefactorytable(header_->get_linktype());
	return ret;
    }
    else
    {
	//ret = new PCapDumpable(header_,db,fragmented,lo);
	ret = (*gendumpable)(header_,(fragmented ? defragment(db) : db),lo);
	RACE_MEMORY_FAIL(!ret,__FILE__,__LINE__,__FUNCTION__);
    }
    return ret;
}

#include"EtherDumpable.h"
PcapInterpreter::factoryfunc_t PcapInterpreter::dumpablefactorytable(u_int32_t linktype)
{
    switch(linktype)
    {
	case DLT_EN10MB: return EtherDumpable::factory;
	default: return PCapDumpable::factory;
    }
}

const char *PcapInterpreter::linktype2str(u_int32_t linktype)
{
    switch(linktype)
    {
	case DLT_NULL   : return "no link-layer encapsulation";
	case DLT_EN10MB : return "Ethernet (10Mb)";
	case DLT_EN3MB  : return "Experimental Ethernet (3Mb)";
	case DLT_AX25        : return "Amateur Radio AX.25";
	case DLT_PRONET      : return "Proteon ProNET Token Ring";
	case DLT_CHAOS       : return "Chaos";
	case DLT_IEEE802     : return "IEEE 802 Networks";
	case DLT_ARCNET      : return "ARCNET, with BSD-style header";
	case DLT_SLIP        : return "Serial Line IP";
	case DLT_PPP         : return "Point-to-point Protocol";
	case DLT_FDDI        : return "FDDI";
	default: return "unknown";
    }
}
