#ifndef PCAPINTERPRETER_H
#define PCAPINTERPRETER_H
#include<RACE_Interpreter.h>
#include<HeaderDumpable.h>
#include<PCapDumpable.h>

class PcapInterpreter : public RACE::Interpreter
{
 public:
    typedef PCapDumpable *(*factoryfunc_t)(HeaderDumpable *header,RACE_Data_Block *db,RACE_LogfileOffset lo);
    PcapInterpreter():headerdump_(false),len_(0),header_(0),
	gendumpable(PCapDumpable::factory) {}
    virtual bool setcontent(RACE_LogfileOffset lo,octet_t *content,size_t len);
    virtual size_t length();
    //##Documentation
    //## Generates the Dumpable
    virtual RACE_Dumpable *interpret(RACE_Data_Block *db,bool fragmented,RACE_LogfileOffset lo);
 private:
    bool headerdump_;
    size_t len_;
    HeaderDumpable *header_;
    factoryfunc_t gendumpable;
    static factoryfunc_t dumpablefactorytable(u_int32_t linktype);
    static const char *linktype2str(u_int32_t linktype);
};
/* aus libpcap:pcap-bdf.h:
 * Data-link level type codes.
 *
 * Do *NOT* add new values to this list without asking
 * "tcpdump-workers@tcpdump.org" for a value.  Otherwise, you run the
 * risk of using a value that's already being used for some other purpose,
 * and of having tools that read libpcap-format captures not being able
 * to handle captures with your new DLT_ value, with no hope that they
 * will ever be changed to do so (as that would destroy their ability
 * to read captures using that value for that other purpose).
 */
                                                                                
/*
 * These are the types that are the same on all platforms, and that
 * have been defined by <net/bpf.h> for ages.
 */
#define DLT_NULL        0       /* no link-layer encapsulation */
#define DLT_EN10MB      1       /* Ethernet (10Mb) */
#define DLT_EN3MB       2       /* Experimental Ethernet (3Mb) */
#define DLT_AX25        3       /* Amateur Radio AX.25 */
#define DLT_PRONET      4       /* Proteon ProNET Token Ring */
#define DLT_CHAOS       5       /* Chaos */
#define DLT_IEEE802     6       /* IEEE 802 Networks */
#define DLT_ARCNET      7       /* ARCNET, with BSD-style header */
#define DLT_SLIP        8       /* Serial Line IP */
#define DLT_PPP         9       /* Point-to-point Protocol */
#define DLT_FDDI        10      /* FDDI */

#endif
